package com.taobao.weex.bridge;

import android.text.TextUtils;
import com.taobao.weex.bridge.WXBridgeManager;
import com.taobao.weex.common.WXJSService;
import io.dcloud.common.util.StringUtil;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

public class WXServiceManager {

   private static volatile ConcurrentHashMap sInstanceJSServiceMap = new ConcurrentHashMap();


   public static boolean registerService(String name, String serviceScript, Map options) {
      if(!TextUtils.isEmpty(name) && !TextUtils.isEmpty(serviceScript)) {
         String param1 = "register: global.registerService, unregister: global.unregisterService";
         String param2 = "serviceName: \"" + name + "\"";
         Iterator serviceJs = options.keySet().iterator();

         while(serviceJs.hasNext()) {
            String service = (String)serviceJs.next();
            Object value = options.get(service);
            if(value instanceof String) {
               param2 = param2 + ", \'" + service + "\': \'" + value + "\'";
            } else {
               param2 = param2 + ", \'" + service + "\': " + value;
            }
         }

         String serviceJs1 = StringUtil.format(";(function(service, options){ ;%s; })({ %s }, { %s });", new Object[]{serviceScript, param1, param2});
         WXJSService service1 = new WXJSService();
         service1.setName(name);
         service1.setScript(serviceScript);
         service1.setOptions(options);
         sInstanceJSServiceMap.put(name, service1);
         WXBridgeManager.getInstance().execJSService(serviceJs1);
         return true;
      } else {
         return false;
      }
   }

   public static boolean unRegisterService(String name) {
      if(TextUtils.isEmpty(name)) {
         return false;
      } else {
         sInstanceJSServiceMap.remove(name);
         String js = StringUtil.format("global.unregisterService( \"%s\" );", new Object[]{name});
         WXBridgeManager.getInstance().execJSService(js);
         return true;
      }
   }

   public static void execAllCacheJsService() {
      Iterator var0 = sInstanceJSServiceMap.keySet().iterator();

      while(var0.hasNext()) {
         String serviceName = (String)var0.next();
         WXJSService service = (WXJSService)sInstanceJSServiceMap.get(serviceName);
         registerService(service.getName(), service.getScript(), service.getOptions());
      }

   }

   public static WXJSService getService(String serviceName) {
      return sInstanceJSServiceMap != null?(WXJSService)sInstanceJSServiceMap.get(serviceName):null;
   }

   public static void reload() {
      if(sInstanceJSServiceMap != null && sInstanceJSServiceMap.size() > 0) {
         WXBridgeManager.getInstance().post(new Runnable() {
            public void run() {
               Iterator var1 = WXServiceManager.sInstanceJSServiceMap.entrySet().iterator();

               while(var1.hasNext()) {
                  Entry entry = (Entry)var1.next();
                  WXJSService service = (WXJSService)entry.getValue();
                  WXServiceManager.registerService(service.getName(), service.getScript(), service.getOptions());
               }

            }
         });
      }

   }

}
